diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
index da552c1f2..ebb468b32 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
@@ -1,49 +1,44 @@
 package net.minecraft.client.gui.container;
 
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityFurnace;
-import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuFurnace;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
-public class ScreenFurnace extends ScreenContainerAbstract
-{
+public class ScreenFurnace extends ScreenContainerAbstract {
 
-    public ScreenFurnace(ContainerInventory inventory, TileEntityFurnace tileEntityFurnace)
-    {
+    public ScreenFurnace(ContainerInventory inventory, TileEntityFurnace tileEntityFurnace) {
         super(new MenuFurnace(inventory, tileEntityFurnace));
-        furnaceInventory = tileEntityFurnace;
+        this.furnaceInventory = tileEntityFurnace;
     }
 
     @Override
-	protected void drawGuiContainerForegroundLayer()
-    {
+    protected void drawGuiContainerForegroundLayer() {
         I18n i18n = I18n.getInstance();
         drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
-        drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        drawStringNoShadow(this.fontRenderer, i18n.translateKey("gui.furnace.label.inventory"), 8, (this.ySize - 96) + 2, 0x404040);
     }
 
     @Override
-	protected void drawGuiContainerBackgroundLayer(float f)
-    {
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        int x = (width - xSize) / 2;
-        int y = (height - ySize) / 2;
-        drawTexturedModalRect(x, y, 0, 0, xSize, ySize);
-        if(furnaceInventory.isBurning())
-        {
-            int fireHeight = furnaceInventory.getBurnTimeRemainingScaled(12);
+    protected void drawGuiContainerBackgroundLayer(float f) {
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        int x = (this.width - this.xSize) / 2;
+        int y = (this.height - this.ySize) / 2;
+        drawTexturedModalRect(x, y, 0, 0, this.xSize, this.ySize);
+        if (this.furnaceInventory.isBurning()) {
+            int fireHeight = this.furnaceInventory.getBurnTimeRemainingScaled(12);
             drawTexturedModalRect(x + 56, y + 36 + 12 - fireHeight, 176, 12 - fireHeight, 14, fireHeight + 2);
-            int arrowWidth = furnaceInventory.getCookProgressScaled(24);
+            int arrowWidth = this.furnaceInventory.getCookProgressScaled(24);
             drawTexturedModalRect(x + 79, y + 34, 176, 14, arrowWidth + 1, 16);
         }
     }
+
     @Override
-    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleFurnace(this);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
index 0b856472b..2eb8e39e0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
@@ -1,14 +1,12 @@
 package net.minecraft.client.gui.container;
 
 import net.minecraft.client.input.controller.ControllerInput;
-import net.minecraft.core.block.entity.TileEntityFurnace;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
-import net.minecraft.core.player.inventory.menu.MenuFurnace;
 import net.minecraft.core.player.inventory.menu.MenuFurnaceBlast;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class ScreenFurnaceBlast
     extends ScreenContainerAbstract
@@ -30,7 +28,7 @@ public class ScreenFurnaceBlast
     @Override
     protected void drawGuiContainerBackgroundLayer(final float f) {
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/blastfurnace.png").bind();
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         final int x = (this.width - this.xSize) / 2;
         final int y = (this.height - this.ySize) / 2;
         drawTexturedModalRect(x, y, 0, 0, this.xSize, this.ySize);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index cacf3487d..47d3a97d4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -1,10 +1,5 @@
 package net.minecraft.client.gui.container;
 
-import static org.lwjgl.opengl.GL11.*;
-
-import java.util.ArrayList;
-import java.util.List;
-
 import it.unimi.dsi.fastutil.ints.IntArrayList;
 import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.gui.ButtonElement;
@@ -13,6 +8,9 @@ import net.minecraft.client.gui.ListLayout;
 import net.minecraft.client.gui.options.OverlayButtonElement;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.entity.EntityRenderer;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.entity.player.Player;
@@ -23,298 +21,286 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.client.option.OptionBoolean;
-import org.lwjgl.opengl.GL12;
 
-public class ScreenInventory extends ScreenContainerAbstract
-{
-	
-	private ButtonElement armorButton;
+public class ScreenInventory extends ScreenContainerAbstract {
+
+    private ButtonElement armorButton;
     protected int armourValuesFloat = 130;
     protected int armourButtonFloatX = 20;
-	protected ListLayout overlayButtonsLayout = new ListLayout(this).setAlign(0.5, 0.5).setVertical(false).setElementSize(11, 11).setOffset(-(xSize / 2), -(ySize / 2) - 10).setMargin(1);
-	private final IntList uvs = new IntArrayList();
-	
-	private DamageType hoveredDamageType;
+    protected float xSize_lo;
+    protected float ySize_lo;
+    protected ListLayout overlayButtonsLayout = new ListLayout(this).setAlign(0.5, 0.5).setVertical(false).setElementSize(11, 11).setOffset(-(this.xSize / 2), -(this.ySize / 2) - 10).setMargin(1);
+    private final IntList uvs = new IntArrayList();
+
+    private DamageType hoveredDamageType;
 
-    public ScreenInventory(Player player)
-    {
+
+    public ScreenInventory(Player player) {
         super(player.inventorySlots);
-        passEvents = true;
+        this.passEvents = true;
         player.addStat(Achievements.OPEN_INVENTORY, 1);
     }
 
     @Override
-	public void init()
-    {
-        buttons.clear();
+    public void init() {
+        this.buttons.clear();
 
 
-        armorButton = new ButtonElement(100, width / 2 - armourButtonFloatX, height / 2 - 74, 9, 9, "");
-        armorButton.visible = false;
+        this.armorButton = new ButtonElement(100, this.width / 2 - this.armourButtonFloatX, this.height / 2 - 74, 9, 9, "");
+        this.armorButton.visible = false;
         checkForArmor();
-        buttons.add(armorButton);
+        this.buttons.add(this.armorButton);
 
-		updateOverlayButtons();
+        updateOverlayButtons();
     }
 
     @Override
-    public void tick(){
+    public void tick() {
         checkForArmor();
     }
-    protected void checkForArmor(){
+
+    protected void checkForArmor() {
         boolean enableArmorButton = false;
 
-        for(int i = 0; i < mc.thePlayer.inventory.armorInventory.length; i++) {
-            ItemStack itemStack = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
-            if(itemStack != null) {
+        for (int i = 0; i < this.mc.thePlayer.inventory.armorInventory.length; i++) {
+            ItemStack itemStack = this.mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
+            if (itemStack != null) {
                 enableArmorButton = true;
                 break;
             }
         }
 
-        armorButton.enabled = enableArmorButton;
+        this.armorButton.enabled = enableArmorButton;
     }
-    
+
     public void updateOverlayButtons() {
-        GameSettings settings = mc.gameSettings;
-        
-		boolean clock = false;
-		boolean compass = false;
-		boolean rotaryCalendar = false;
-
-		if (mc.thePlayer.getGamemode() == Gamemode.creative) {
-			clock = true;
-			compass = true;
-			rotaryCalendar = true;
-		} else {
-			for (int iinv = 0; iinv < mc.thePlayer.inventory.getContainerSize(); iinv++) {
-				ItemStack item = mc.thePlayer.inventory.getItem(iinv);
-				if (item != null) {
-					if (item.itemID == Items.TOOL_CLOCK.id) {
-						clock = true;
-					}
-					if (item.itemID == Items.TOOL_COMPASS.id) {
-						compass = true;
-					}
-					if (item.itemID == Items.TOOL_CALENDAR.id) {
-						rotaryCalendar = true;
-					}
-				}
-			}
-		}
-		
-		
-        overlayButtonsLayout.elements.clear();
-        
-        if(compass) {
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowCoords));
-        	uvs.add(0);
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowDirection));
-        	uvs.add(1);
+        GameSettings settings = this.mc.gameSettings;
+
+        boolean clock = false;
+        boolean compass = false;
+        boolean rotaryCalendar = false;
+
+        if (this.mc.thePlayer.getGamemode() == Gamemode.creative) {
+            clock = true;
+            compass = true;
+            rotaryCalendar = true;
+        } else {
+            for (int iinv = 0; iinv < this.mc.thePlayer.inventory.getContainerSize(); iinv++) {
+                ItemStack item = this.mc.thePlayer.inventory.getItem(iinv);
+                if (item != null) {
+                    if (item.itemID == Items.TOOL_CLOCK.id) {
+                        clock = true;
+                    }
+                    if (item.itemID == Items.TOOL_COMPASS.id) {
+                        compass = true;
+                    }
+                    if (item.itemID == Items.TOOL_CALENDAR.id) {
+                        rotaryCalendar = true;
+                    }
+                }
+            }
         }
-        if(clock) {
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowTime));
-        	uvs.add(2);
+
+
+        this.overlayButtonsLayout.elements.clear();
+
+        if (compass) {
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowCoords));
+            this.uvs.add(0);
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowDirection));
+            this.uvs.add(1);
         }
-        if(rotaryCalendar) {
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowSeason));
-        	uvs.add(3);
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowWeather));
-        	uvs.add(4);
-        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowBiome));
-        	uvs.add(5);
+        if (clock) {
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowTime));
+            this.uvs.add(2);
         }
-        
-        overlayButtonsLayout.updateElementPositions();
-        
-        for (GuiElement element : overlayButtonsLayout.elements) {
-    		ButtonElement button = (ButtonElement) element;
-    		button.visible = false;
-    		buttons.add(button);
+        if (rotaryCalendar) {
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowSeason));
+            this.uvs.add(3);
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowWeather));
+            this.uvs.add(4);
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowBiome));
+            this.uvs.add(5);
+        }
+
+        this.overlayButtonsLayout.updateElementPositions();
+
+        for (GuiElement element : this.overlayButtonsLayout.elements) {
+            ButtonElement button = (ButtonElement) element;
+            button.visible = false;
+            this.buttons.add(button);
         }
     }
 
     @Override
-	protected void drawGuiContainerForegroundLayer()
-    {
+    protected void drawGuiContainerForegroundLayer() {
         drawStringNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.inventory.label.crafting"), 86, 16, 0x404040);
     }
 
     @Override
-	public void render(int mx, int my, float partialTick)
-    {
+    public void render(int mx, int my, float partialTick) {
         super.render(mx, my, partialTick);
-        xSize_lo = mx;
-        ySize_lo = my;
+        this.xSize_lo = mx;
+        this.ySize_lo = my;
 
-        if(mc.gameSettings.armorProtectionOverlay.value && armorButton.enabled) {
-        	drawProtectionOverlay(mx, my);
+        if (this.mc.gameSettings.armorProtectionOverlay.value && this.armorButton.enabled) {
+            drawProtectionOverlay(mx, my);
         }
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
-        
-        glColor4d(1.0, 1.0, 1.0, 1.0);
-        glDisable(GL_BLEND);
-        glEnable(GL_TEXTURE_2D);
-        
-        if(armorButton.enabled) {
-            if(armorButton.isHovered(mx, my)) {
-            	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 185, 0, armorButton.width, armorButton.height);
-            }else {
-            	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 176, 0, armorButton.width, armorButton.height);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
+
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        GLRenderer.enableState(State.BLEND);
+
+        if (this.armorButton.enabled) {
+            if (this.armorButton.isHovered(mx, my)) {
+                drawTexturedModalRect(this.armorButton.xPosition, this.armorButton.yPosition, 185, 0, this.armorButton.width, this.armorButton.height);
+            } else {
+                drawTexturedModalRect(this.armorButton.xPosition, this.armorButton.yPosition, 176, 0, this.armorButton.width, this.armorButton.height);
             }
         }
-        
-        for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
-        	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
-        	drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * uvs.getInt(i), 9, 9);
-        	boolean val = true;
-        	if(button.option instanceof OptionBoolean) val = (Boolean) button.option.value;
-        	if(!val) drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 194, 0, 9, 9);
+
+        for (int i = 0; i < this.overlayButtonsLayout.elements.size(); i++) {
+            OverlayButtonElement<?> button = (OverlayButtonElement<?>) this.overlayButtonsLayout.elements.get(i);
+            drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * this.uvs.getInt(i), 9, 9);
+            boolean val = true;
+            if (button.option instanceof OptionBoolean) val = (Boolean) button.option.value;
+            if (!val) drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 194, 0, 9, 9);
         }
 
-        for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
-        	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
-        	if(button.isHovered(mx, my))
-            {
-                tooltipElement.render(button.option.getDisplayStringName() + ": " + button.displayString, mx, my, 8, -8);
-        	}
+        for (int i = 0; i < this.overlayButtonsLayout.elements.size(); i++) {
+            OverlayButtonElement<?> button = (OverlayButtonElement<?>) this.overlayButtonsLayout.elements.get(i);
+            if (button.isHovered(mx, my)) {
+                this.tooltipElement.render(button.option.getDisplayStringName() + ": " + button.displayString, mx, my, 8, -8);
+            }
         }
-        
+
     }
-    
+
     protected Color protectionOverlayBgColor = new Color().setRGBA(0, 0, 0, 127);
 
+
     public void drawProtectionOverlay(int mouseX, int mouseY) {
-        hoveredDamageType = null;
-        
-    	int x = width / 2 - armourValuesFloat - 4;
-    	int y = height / 2 - 79;
-    	
-    	int w = 44;
-    	int h = 44;
+        this.hoveredDamageType = null;
 
-        glEnable(GL_BLEND);
-        drawGradientRect(x, y, x + w, y + h, protectionOverlayBgColor.getARGB(), protectionOverlayBgColor.getARGB());
+        int x = this.width / 2 - this.armourValuesFloat - 4;
+        int y = this.height / 2 - 79;
 
-        glDisable(GL_BLEND);
-        glDisable(GL_CULL_FACE);
+        int w = 44;
+        int h = 44;
+
+        drawGradientRect(x, y, x + w, y + h, this.protectionOverlayBgColor.getARGB(), this.protectionOverlayBgColor.getARGB());
+
+        GLRenderer.disableState(State.BLEND);
+        GLRenderer.disableState(State.CULL_FACE);
 
         int w2 = 26;
-		int x2 = x;
-		int h2 = 4;
-		
-        int i=0;
-        for(DamageType damageType : DamageType.values()) {
-        	if(damageType.shouldDisplay()) {
-        		int y2 = y + i * 10;
-        		
-            	float protection = mc.thePlayer.getTotalProtectionAmount(damageType);
-            	if(protection > 1) protection = 1.0f;
+        int x2 = x;
+        int h2 = 4;
+
+        int i = 0;
+        for (DamageType damageType : DamageType.values()) {
+            if (damageType.shouldDisplay()) {
+                int y2 = y + i * 10;
+
+                float protection = this.mc.thePlayer.getTotalProtectionAmount(damageType);
+                if (protection > 1) protection = 1.0f;
 
                 int l = (int) (protection * 255);
-    			final int color = (255 - l << 16 | l << 8) | 0xFF000000;
+                final int color = (255 - l << 16 | l << 8) | 0xFF000000;
 //    			fontRenderer.drawStringWithShadow(Utils.percent(protection)+"%", x + 15, y + 3 + i * 10, color);
-    			
-    			glEnable(GL_TEXTURE_2D);
-    			glColor4d(1.0, 1.0, 1.0, 1.0);
+
+                GLRenderer.setColor4f(1f, 1f, 1f, 1f);
                 drawGuiIcon(x2 + 2, y2 + 2, 9, 9, TextureRegistry.getTexture(damageType.getIcon()));
-    			
-    			glDisable(GL_TEXTURE_2D);
-    			
-    			drawRectWidthHeight(x2 + 14, y2 + 4, w2+2, h2+1, 0xFF000000);
-    			drawRectWidthHeight(x2 + 15, y2 + 4, (int)(protection * w2), h2, color);
-    			
-    			if(mouseX >= x2&& mouseY >= y2 + 2 && mouseX <= x2 + w && mouseY <= y2 + 12 ) {
-    				hoveredDamageType = damageType;
-    			}
-        	}
-        	i++;
+
+
+                drawRectWidthHeight(x2 + 14, y2 + 4, w2 + 2, h2 + 1, 0xFF000000);
+                drawRectWidthHeight(x2 + 15, y2 + 4, (int) (protection * w2), h2, color);
+
+                if (mouseX >= x2 && mouseY >= y2 + 2 && mouseX <= x2 + w && mouseY <= y2 + 12) {
+                    this.hoveredDamageType = damageType;
+                }
+            }
+            i++;
         }
-        
-        glEnable(GL_TEXTURE_2D);
-        
-        if(hoveredDamageType != null) {
-        	int protection = Math.round(mc.thePlayer.getTotalProtectionAmount(hoveredDamageType) * 100);
-        	if(protection < 0) {
-        		protection = 0;
-        	}
-        	if(protection > 100) {
-        		protection = 100;
-        	}
-
-        	String str = I18n.getInstance().translateKey(hoveredDamageType.getLanguageKey()) + ":\n" + protection + " / 100";
-        	
-        	tooltipElement.render(str, mouseX, mouseY, 8, -8);
+
+        if (this.hoveredDamageType != null) {
+            int protection = Math.round(this.mc.thePlayer.getTotalProtectionAmount(this.hoveredDamageType) * 100);
+            if (protection < 0) {
+                protection = 0;
+            }
+            if (protection > 100) {
+                protection = 100;
+            }
+
+            String str = I18n.getInstance().translateKey(this.hoveredDamageType.getLanguageKey()) + ":\n" + protection + " / 100";
+
+            this.tooltipElement.render(str, mouseX, mouseY, 8, -8);
         }
     }
 
     @Override
-	protected void drawGuiContainerBackgroundLayer(float f)
-    {
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
-        int j = (width - xSize) / 2;
-        int k = (height - ySize) / 2;
-        drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
-
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glPushMatrix();
-        GL11.glTranslatef(j + 51, k + 75, 50F);
+    protected void drawGuiContainerBackgroundLayer(float f) {
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
+        int j = (this.width - this.xSize) / 2;
+        int k = (this.height - this.ySize) / 2;
+        drawTexturedModalRect(j, k, 0, 0, this.xSize, this.ySize);
+
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.getFogState().disable();
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.modelM4f().translate(j + 51, k + 75, 50F);
         float f1 = 30F;
-        GL11.glScalef(-f1, f1, f1);
-        GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-        float f2 = mc.thePlayer.yBodyRot;
-        float f3 = mc.thePlayer.yRot;
-        float f4 = mc.thePlayer.xRot;
-        float f5 = (float)(j + 51) - xSize_lo;
-        float f6 = (float)((k + 75) - 50) - ySize_lo;
-        GL11.glRotatef(135F, 0.0F, 1.0F, 0.0F);
+        GLRenderer.modelM4f().scale(-f1, f1, f1);
+        GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(180F));
+        float f2 = this.mc.thePlayer.yBodyRot;
+        float f3 = this.mc.thePlayer.yRot;
+        float f4 = this.mc.thePlayer.xRot;
+        float f5 = (float) (j + 51) - this.xSize_lo;
+        float f6 = (float) ((k + 75) - 50) - this.ySize_lo;
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
-        GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-(float)Math.atan(f6 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
-        mc.thePlayer.yBodyRot = (float)Math.atan(f5 / 40F) * 20F;
-        mc.thePlayer.yRot = (float)Math.atan(f5 / 40F) * 40F;
-        mc.thePlayer.xRot = -(float)Math.atan(f6 / 40F) * 20F;
-        mc.thePlayer.entityBrightness = 1.0F;
-        GL11.glTranslatef(0.0F, mc.thePlayer.heightOffset, 0.0F);
-        EntityRenderDispatcher.instance.viewLerpYaw = 180F;
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
+        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(f6 / 40F) * 20F));
+        this.mc.thePlayer.yBodyRot = (float) Math.atan(f5 / 40F) * 20F;
+        this.mc.thePlayer.yRot = (float) Math.atan(f5 / 40F) * 40F;
+        this.mc.thePlayer.xRot = -(float) Math.atan(f6 / 40F) * 20F;
+        this.mc.thePlayer.entityBrightness = 1.0F;
+        GLRenderer.modelM4f().translate(0.0F, this.mc.thePlayer.heightOffset, 0.0F);
+        EntityRendererDispatcher.instance.viewLerpYaw = 180F;
         EntityRenderer.renderShadows = false;
-        EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(Tessellator.instance, mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
+        GLRenderer.globalGetNormalTransformMatrix().scale(1, -1, 1);
+        EntityRendererDispatcher.instance.renderEntityPreviewWithPosYaw(GLRenderer.getTessellator(), this.mc.thePlayer, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
         EntityRenderer.renderShadows = true;
-        mc.thePlayer.entityBrightness = 0.0F;
-        mc.thePlayer.yBodyRot = f2;
-        mc.thePlayer.yRot = f3;
-        mc.thePlayer.xRot = f4;
-        GL11.glPopMatrix();
+        this.mc.thePlayer.entityBrightness = 0.0F;
+        this.mc.thePlayer.yBodyRot = f2;
+        this.mc.thePlayer.yRot = f3;
+        this.mc.thePlayer.xRot = f4;
+        GLRenderer.popFrame();
         Lighting.disable();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     @Override
-	protected void buttonClicked(@NotNull ButtonElement button)
-    {
-        if (button == armorButton) {
-        	mc.gameSettings.armorProtectionOverlay.toggle();
+    protected void buttonClicked(@NotNull ButtonElement button) {
+        if (button == this.armorButton) {
+            this.mc.gameSettings.armorProtectionOverlay.toggle();
         }
     }
 
     @Override
-    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleInventory(this);
     }
 
-    protected float xSize_lo;
-    protected float ySize_lo;
-
 }
